Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/components/FacetPanel.html
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/components/FacetPanel.html	(revision 4498)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/components/FacetPanel.html	(revision 4499)
@@ -27,5 +27,5 @@
             <a href="#" class="expandfacet"><span>expand</span></a>
             <a href="#" class="collapsefacet"><span>collapse</span></a>
-            <h1><a href="#"><wicket:container wicket:id="facet.name">[TITLE]</wicket:container></a></h1>
+            <h1><a href="#"><wicket:container wicket:id="selection.facet.name">[TITLE]</wicket:container></a></h1>
             <a href class="filtertoggle"><span>filter</span></a>
             <form class="filterform">
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/components/FacetPanel.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/components/FacetPanel.java	(revision 4498)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/components/FacetPanel.java	(revision 4499)
@@ -17,5 +17,5 @@
 package eu.clarin.cmdi.vlo.components;
 
-import eu.clarin.cmdi.vlo.pojo.FacetSelection;
+import eu.clarin.cmdi.vlo.pojo.FacetStatus;
 import org.apache.wicket.markup.html.basic.Label;
 import org.apache.wicket.markup.html.panel.Panel;
@@ -29,9 +29,9 @@
 public class FacetPanel extends Panel {
 
-    public FacetPanel(String id, IModel<FacetSelection> model) {
+    public FacetPanel(String id, IModel<FacetStatus> model) {
         super(id, model);
-        setDefaultModel(new CompoundPropertyModel<FacetSelection>(model));
+        setDefaultModel(new CompoundPropertyModel<FacetStatus>(model));
         
-        add(new Label("facet.name"));
+        add(new Label("selection.facet.name"));
     }
 
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/components/FacetsPanel.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/components/FacetsPanel.java	(revision 4498)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/components/FacetsPanel.java	(revision 4499)
@@ -17,5 +17,5 @@
 package eu.clarin.cmdi.vlo.components;
 
-import eu.clarin.cmdi.vlo.pojo.FacetSelection;
+import eu.clarin.cmdi.vlo.pojo.FacetStatus;
 import org.apache.wicket.markup.html.list.ListItem;
 import org.apache.wicket.markup.html.list.ListView;
@@ -29,10 +29,10 @@
 public class FacetsPanel extends Panel {
 
-    public FacetsPanel(String id, ListModel<FacetSelection> model) {
+    public FacetsPanel(String id, ListModel<FacetStatus> model) {
         super(id, model);
-        add(new ListView<FacetSelection>("facets", model) {
+        add(new ListView<FacetStatus>("facets", model) {
 
             @Override
-            protected void populateItem(ListItem<FacetSelection> item) {
+            protected void populateItem(ListItem<FacetStatus> item) {
                 //TODO: Check whether a value has been selected or not
                 item.add(new FacetPanel("facet", item.getModel()));
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/pages/FacetedSearchPage.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/pages/FacetedSearchPage.java	(revision 4498)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/pages/FacetedSearchPage.java	(revision 4499)
@@ -4,5 +4,7 @@
 import eu.clarin.cmdi.vlo.pojo.Facet;
 import eu.clarin.cmdi.vlo.pojo.FacetSelection;
+import eu.clarin.cmdi.vlo.pojo.FacetStatus;
 import java.util.Arrays;
+import java.util.Collection;
 import java.util.Collections;
 import org.apache.wicket.request.mapper.parameter.PageParameters;
@@ -16,9 +18,11 @@
     public FacetedSearchPage(final PageParameters parameters) {
         super(parameters);
-
-        add(new FacetsPanel("facets", new ListModel<FacetSelection>(Arrays.asList(
-                new FacetSelection(new Facet("Language"), Collections.singleton("Dutch")),
-                new FacetSelection(new Facet("Resource type"), Collections.singleton("Text"))
-        ))));
+        final FacetSelection languageSelection = new FacetSelection(new Facet("Language"), Collections.singleton("Dutch"));
+        final FacetSelection typeSelection = new FacetSelection(new Facet("Resource type"), Collections.<String>emptySet());
+        final Collection<FacetSelection> context = Arrays.asList(languageSelection,typeSelection);
+        
+        add(new FacetsPanel("facets", new ListModel<FacetStatus>(Arrays.asList(
+                new FacetStatus(languageSelection, context),
+                new FacetStatus(typeSelection, context)))));
     }
 }
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/pojo/FacetStatus.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/pojo/FacetStatus.java	(revision 4499)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/pojo/FacetStatus.java	(revision 4499)
@@ -0,0 +1,51 @@
+/*
+ * Copyright (C) 2014 CLARIN
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+package eu.clarin.cmdi.vlo.pojo;
+
+import java.util.Collection;
+
+/**
+ *
+ * @author twagoo
+ */
+public class FacetStatus {
+
+    private final FacetSelection selection;
+    private final Collection<FacetSelection> context;
+
+    public FacetStatus(FacetSelection selection, Collection<FacetSelection> context) {
+        this.selection = selection;
+        this.context = context;
+    }
+
+    /**
+     * 
+     * @return selections of other facets
+     */
+    public Collection<FacetSelection> getContext() {
+        return context;
+    }
+
+    /**
+     * 
+     * @return facet and value for the current facet
+     */
+    public FacetSelection getSelection() {
+        return selection;
+    }
+
+}
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/test/java/eu/clarin/cmdi/vlo/Start.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/test/java/eu/clarin/cmdi/vlo/Start.java	(revision 4498)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/test/java/eu/clarin/cmdi/vlo/Start.java	(revision 4499)
@@ -19,5 +19,5 @@
         connector.setMaxIdleTime(timeout);
         connector.setSoLingerTime(-1);
-        connector.setPort(8080);
+        connector.setPort(8090);
         server.addConnector(connector);
 