Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/components/FacetPanel.html
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/components/FacetPanel.html	(revision 4499)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/components/FacetPanel.html	(revision 4500)
@@ -27,5 +27,5 @@
             <a href="#" class="expandfacet"><span>expand</span></a>
             <a href="#" class="collapsefacet"><span>collapse</span></a>
-            <h1><a href="#"><wicket:container wicket:id="selection.facet.name">[TITLE]</wicket:container></a></h1>
+            <h1><a href="#"><wicket:container wicket:id="name">[TITLE]</wicket:container></a></h1>
             <a href class="filtertoggle"><span>filter</span></a>
             <form class="filterform">
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/components/FacetPanel.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/components/FacetPanel.java	(revision 4499)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/components/FacetPanel.java	(revision 4500)
@@ -17,5 +17,5 @@
 package eu.clarin.cmdi.vlo.components;
 
-import eu.clarin.cmdi.vlo.pojo.FacetStatus;
+import org.apache.solr.client.solrj.response.FacetField;
 import org.apache.wicket.markup.html.basic.Label;
 import org.apache.wicket.markup.html.panel.Panel;
@@ -29,9 +29,9 @@
 public class FacetPanel extends Panel {
 
-    public FacetPanel(String id, IModel<FacetStatus> model) {
+    public FacetPanel(String id, IModel<FacetField> model) {
         super(id, model);
-        setDefaultModel(new CompoundPropertyModel<FacetStatus>(model));
+        setDefaultModel(new CompoundPropertyModel<FacetField>(model));
         
-        add(new Label("selection.facet.name"));
+        add(new Label("name"));
     }
 
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/components/FacetsPanel.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/components/FacetsPanel.java	(revision 4499)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/components/FacetsPanel.java	(revision 4500)
@@ -17,5 +17,5 @@
 package eu.clarin.cmdi.vlo.components;
 
-import eu.clarin.cmdi.vlo.pojo.FacetStatus;
+import org.apache.solr.client.solrj.response.FacetField;
 import org.apache.wicket.markup.html.list.ListItem;
 import org.apache.wicket.markup.html.list.ListView;
@@ -29,10 +29,10 @@
 public class FacetsPanel extends Panel {
 
-    public FacetsPanel(String id, ListModel<FacetStatus> model) {
+    public FacetsPanel(String id, ListModel<FacetField> model) {
         super(id, model);
-        add(new ListView<FacetStatus>("facets", model) {
+        add(new ListView<FacetField>("facets", model) {
 
             @Override
-            protected void populateItem(ListItem<FacetStatus> item) {
+            protected void populateItem(ListItem<FacetField> item) {
                 //TODO: Check whether a value has been selected or not
                 item.add(new FacetPanel("facet", item.getModel()));
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/pages/FacetedSearchPage.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/pages/FacetedSearchPage.java	(revision 4499)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/pages/FacetedSearchPage.java	(revision 4500)
@@ -2,10 +2,6 @@
 
 import eu.clarin.cmdi.vlo.components.FacetsPanel;
-import eu.clarin.cmdi.vlo.pojo.Facet;
-import eu.clarin.cmdi.vlo.pojo.FacetSelection;
-import eu.clarin.cmdi.vlo.pojo.FacetStatus;
 import java.util.Arrays;
-import java.util.Collection;
-import java.util.Collections;
+import org.apache.solr.client.solrj.response.FacetField;
 import org.apache.wicket.request.mapper.parameter.PageParameters;
 import org.apache.wicket.markup.html.WebPage;
@@ -18,11 +14,8 @@
     public FacetedSearchPage(final PageParameters parameters) {
         super(parameters);
-        final FacetSelection languageSelection = new FacetSelection(new Facet("Language"), Collections.singleton("Dutch"));
-        final FacetSelection typeSelection = new FacetSelection(new Facet("Resource type"), Collections.<String>emptySet());
-        final Collection<FacetSelection> context = Arrays.asList(languageSelection,typeSelection);
         
-        add(new FacetsPanel("facets", new ListModel<FacetStatus>(Arrays.asList(
-                new FacetStatus(languageSelection, context),
-                new FacetStatus(typeSelection, context)))));
+        add(new FacetsPanel("facets", new ListModel<FacetField>(Arrays.asList(
+                new FacetField("Language"),
+                new FacetField("Resource type")))));
     }
 }
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/FacetValuesService.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/FacetValuesService.java	(revision 4499)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/FacetValuesService.java	(revision 4500)
@@ -15,10 +15,11 @@
  * along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
-
 package eu.clarin.cmdi.vlo.service;
 
 import eu.clarin.cmdi.vlo.pojo.Facet;
+import eu.clarin.cmdi.vlo.pojo.FacetSelection;
 import eu.clarin.cmdi.vlo.pojo.FacetValue;
 import eu.clarin.cmdi.vlo.service.impl.FacetValuesProvider;
+import java.util.Collection;
 import java.util.List;
 
@@ -29,5 +30,6 @@
 public interface FacetValuesService {
 
-    public List<FacetValue> getValues(Facet facet, String startsWith, FacetValuesProvider.FacetValuesSortProperty sort);
-    public long getValueCount(Facet facet, String startsWith);
+    public List<FacetValue> getValues(Facet facet, Collection<FacetSelection> context, String startsWith, FacetValuesProvider.FacetValuesSortProperty sort);
+
+    public long getValueCount(Facet facet, Collection<FacetSelection> context, String startsWith);
 }
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/FacetValuesProvider.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/FacetValuesProvider.java	(revision 4499)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/FacetValuesProvider.java	(revision 4500)
@@ -19,4 +19,5 @@
 import eu.clarin.cmdi.vlo.service.FacetValuesService;
 import eu.clarin.cmdi.vlo.pojo.Facet;
+import eu.clarin.cmdi.vlo.pojo.FacetStatus;
 import eu.clarin.cmdi.vlo.pojo.FacetValue;
 import eu.clarin.cmdi.vlo.service.impl.FacetValuesProvider.FacetValuesSortProperty;
@@ -38,10 +39,10 @@
     }
     private final FacetValuesService fvService;
-    private final Facet facet;
+    private final IModel<FacetStatus> status;
     private final String filter;
 
-    public FacetValuesProvider(FacetValuesService fvService, Facet facet, String filter) {
+    public FacetValuesProvider(FacetValuesService fvService, IModel<FacetStatus> status, String filter) {
         this.fvService = fvService;
-        this.facet = facet;
+        this.status = status;
         this.filter = filter;
     }
@@ -49,10 +50,17 @@
     @Override
     public Iterator<? extends FacetValue> iterator(long first, long count) {
-        return fvService.getValues(facet, filter, FacetValuesSortProperty.NAME).listIterator((int) first);
+        return fvService.getValues(
+                status.getObject().getSelection().getFacet(),
+                status.getObject().getContext(),
+                filter,
+                FacetValuesSortProperty.NAME).listIterator((int) first);
     }
 
     @Override
     public long size() {
-        return fvService.getValueCount(facet, filter);
+        return fvService.getValueCount(
+                status.getObject().getSelection().getFacet(),
+                status.getObject().getContext(),
+                filter);
     }
 
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/SolrFacetValuesService.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/SolrFacetValuesService.java	(revision 4500)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/SolrFacetValuesService.java	(revision 4500)
@@ -0,0 +1,45 @@
+/*
+ * Copyright (C) 2014 CLARIN
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+package eu.clarin.cmdi.vlo.service.impl;
+
+import eu.clarin.cmdi.vlo.pojo.Facet;
+import eu.clarin.cmdi.vlo.pojo.FacetSelection;
+import eu.clarin.cmdi.vlo.pojo.FacetValue;
+import eu.clarin.cmdi.vlo.service.FacetValuesService;
+import java.util.Collection;
+import java.util.List;
+
+/**
+ *
+ * @author twagoo
+ */
+public class SolrFacetValuesService implements FacetValuesService {
+
+    @Override
+    public List<FacetValue> getValues(Facet facet, Collection<FacetSelection> context, String startsWith, FacetValuesProvider.FacetValuesSortProperty sort) {
+        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
+    }
+
+    @Override
+    public long getValueCount(Facet facet, Collection<FacetSelection> context, String startsWith) {
+        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
+    }
+
+
+    
+}