Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/config/VloSpringConfig.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/config/VloSpringConfig.java	(revision 4501)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/config/VloSpringConfig.java	(revision 4502)
@@ -24,5 +24,6 @@
 import eu.clarin.cmdi.vlo.service.impl.SolrFacetFieldsService;
 import eu.clarin.cmdi.vlo.service.impl.SolrQueryFactoryImpl;
-import org.springframework.beans.factory.annotation.Value;
+import org.apache.solr.client.solrj.SolrServer;
+import org.apache.solr.client.solrj.impl.HttpSolrServer;
 import org.springframework.context.annotation.Bean;
 import org.springframework.context.annotation.Configuration;
@@ -63,9 +64,15 @@
     @Bean
     public SearchResultsDao searchResultsDao() {
-        return new SearchResultsDaoImpl(vloConfig().getSolrUrl());
+        return new SearchResultsDaoImpl(solrServer());
     }
 
+    @Bean
     public SolrQueryFactory queryFactory() {
         return new SolrQueryFactoryImpl();
     }
+    
+    @Bean
+    public SolrServer solrServer() {
+        return new HttpSolrServer(vloConfig().getSolrUrl());
+    }
 }
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/AutoCompleteDao.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/AutoCompleteDao.java	(revision 4501)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/AutoCompleteDao.java	(revision 4502)
@@ -6,4 +6,5 @@
 
 import org.apache.solr.client.solrj.SolrQuery;
+import org.apache.solr.client.solrj.SolrServer;
 import org.apache.solr.client.solrj.response.QueryResponse;
 import org.apache.solr.client.solrj.response.SpellCheckResponse.Suggestion;
@@ -17,6 +18,6 @@
 public class AutoCompleteDao extends SolrDaoImpl {
 
-    public AutoCompleteDao(String solrUrl) {
-        super(solrUrl);
+    public AutoCompleteDao(SolrServer solrServer) {
+        super(solrServer);
     }
     
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/SearchResultsDaoImpl.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/SearchResultsDaoImpl.java	(revision 4501)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/SearchResultsDaoImpl.java	(revision 4502)
@@ -5,4 +5,5 @@
 import java.util.List;
 import org.apache.solr.client.solrj.SolrQuery;
+import org.apache.solr.client.solrj.SolrServer;
 import org.apache.solr.client.solrj.response.FacetField;
 import org.apache.solr.client.solrj.response.QueryResponse;
@@ -11,6 +12,6 @@
 public class SearchResultsDaoImpl extends SolrDaoImpl implements SearchResultsDao {
 
-    public SearchResultsDaoImpl(String solrUrl) {
-        super(solrUrl);
+    public SearchResultsDaoImpl(SolrServer solrServer) {
+        super(solrServer);
     }
 
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/SolrDaoImpl.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/SolrDaoImpl.java	(revision 4501)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/SolrDaoImpl.java	(revision 4502)
@@ -2,11 +2,10 @@
 
 import eu.clarin.cmdi.vlo.config.VloConfig;
-import java.net.MalformedURLException;
 import java.util.Arrays;
 import java.util.HashSet;
 import java.util.Set;
 import org.apache.solr.client.solrj.SolrQuery;
+import org.apache.solr.client.solrj.SolrServer;
 import org.apache.solr.client.solrj.SolrServerException;
-import org.apache.solr.client.solrj.impl.HttpSolrServer;
 import org.apache.solr.client.solrj.response.QueryResponse;
 import org.apache.solr.client.solrj.util.ClientUtils;
@@ -17,13 +16,13 @@
 
 public class SolrDaoImpl {
+    
+    private final static Logger LOG = LoggerFactory.getLogger(SolrDaoImpl.class);
+    private final SolrServer solrServer;
 
-    private final static Logger LOG = LoggerFactory.getLogger(SolrDaoImpl.class);
-    private final HttpSolrServer solrServer;
-
-    public SolrDaoImpl(String solrUrl) {
-        solrServer = new HttpSolrServer(solrUrl);
+    public SolrDaoImpl(SolrServer solrServer) {
+        this.solrServer = solrServer;
     }
 
-    protected HttpSolrServer getSolrserver() {
+    protected SolrServer getSolrserver() {
         return solrServer;
     }