Index: /vlo/branches/vlo-3.0/vlo-commons/src/main/java/eu/clarin/cmdi/vlo/config/XmlVloConfigFactory.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-commons/src/main/java/eu/clarin/cmdi/vlo/config/XmlVloConfigFactory.java	(revision 4519)
+++ /vlo/branches/vlo-3.0/vlo-commons/src/main/java/eu/clarin/cmdi/vlo/config/XmlVloConfigFactory.java	(revision 4520)
@@ -22,4 +22,5 @@
 
 /**
+ * Factory that reads a VLO configuration from a URL (typically a local file)
  *
  * @author twagoo
@@ -29,4 +30,8 @@
     private final URL configLocation;
 
+    /**
+     * 
+     * @param configLocation URL from which the configuration should be read
+     */
     public XmlVloConfigFactory(URL configLocation) {
         this.configLocation = configLocation;
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/pojo/QueryFacetsSelection.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/pojo/QueryFacetsSelection.java	(revision 4519)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/pojo/QueryFacetsSelection.java	(revision 4520)
@@ -23,4 +23,5 @@
 
 /**
+ * Represents a query and any number of selected values for zero or more facets
  *
  * @author twagoo
@@ -32,5 +33,5 @@
 
     /**
-     * creates an empty selection (no string, no facet values)
+     * Creates an empty selection (no string, no facet values)
      */
     public QueryFacetsSelection() {
@@ -39,5 +40,5 @@
 
     /**
-     * creates a selection without a query
+     * Creates a selection without a query
      *
      * @param selection facet values selection map
@@ -48,5 +49,5 @@
 
     /**
-     * creates a selection with a textual query and facet value selection
+     * Creates a selection with a textual query and facet value selection
      *
      * @param query textual query
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/FacetFieldsService.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/FacetFieldsService.java	(revision 4519)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/FacetFieldsService.java	(revision 4520)
@@ -15,5 +15,4 @@
  * along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
-
 package eu.clarin.cmdi.vlo.service;
 
@@ -23,11 +22,21 @@
 
 /**
+ * A service that retrieves facet fields based on pre-formulated SOLR query
  *
  * @author twagoo
  */
 public interface FacetFieldsService {
-    
+
+    /**
+     * 
+     * @param selection query and selected facet values
+     * @return facet field objects representing the state of all present facets
+     */
     List<FacetField> getFacetFields(QueryFacetsSelection selection);
-    
+
+    /**
+     * 
+     * @return the total number of facets
+     */
     long getFacetFieldCount();
 }
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/SolrQueryFactory.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/SolrQueryFactory.java	(revision 4519)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/SolrQueryFactory.java	(revision 4520)
@@ -21,4 +21,6 @@
 
 /**
+ * A factory that constructs SOLR queries to be used in various services for
+ * data providers etc.
  *
  * @author twagoo
@@ -27,5 +29,5 @@
 
     SolrQuery createFacetQuery(QueryFacetsSelection selection);
-    
+
     SolrQuery createCountFacetsQuery();
 
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/FacetFieldsDataProvider.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/FacetFieldsDataProvider.java	(revision 4519)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/FacetFieldsDataProvider.java	(revision 4520)
@@ -27,4 +27,5 @@
 
 /**
+ * Provides FacetField objects given a selection
  *
  * @author twagoo
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/SolrFacetFieldsService.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/SolrFacetFieldsService.java	(revision 4519)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/SolrFacetFieldsService.java	(revision 4520)
@@ -25,4 +25,6 @@
 
 /**
+ * Gets FacetFields from SOLR based on a selection and the queries constructed
+ * by the provided query factory
  *
  * @author twagoo
@@ -33,4 +35,9 @@
     private final SolrQueryFactory queryFatory;
 
+    /**
+     * 
+     * @param searchResultsDao DAO to use to retrieve facets
+     * @param queryFatory factory to use to construct facet queries
+     */
     public SolrFacetFieldsService(SearchResultsDao searchResultsDao, SolrQueryFactory queryFatory) {
         this.searchResultsDao = searchResultsDao;
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/SolrQueryFactoryImpl.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/SolrQueryFactoryImpl.java	(revision 4519)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/SolrQueryFactoryImpl.java	(revision 4520)
@@ -29,4 +29,6 @@
 
 /**
+ * Implements a SOLR query factory, to be used by SOLR service implementation
+ * for the VLO
  *
  * @author twagoo
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/FacetPanel.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/FacetPanel.java	(revision 4519)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/FacetPanel.java	(revision 4520)
@@ -24,4 +24,5 @@
 
 /**
+ * A panel representing a single facet
  *
  * @author twagoo
@@ -32,5 +33,5 @@
         super(id, model);
         setDefaultModel(new CompoundPropertyModel<FacetField>(model));
-        
+
         add(new Label("name"));
     }
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/FacetsPanel.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/FacetsPanel.java	(revision 4519)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/FacetsPanel.java	(revision 4520)
@@ -28,4 +28,5 @@
 
 /**
+ * A panel representing a group of facets
  *
  * @author twagoo
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/pages/FacetedSearchPage.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/pages/FacetedSearchPage.java	(revision 4519)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/pages/FacetedSearchPage.java	(revision 4520)
@@ -5,8 +5,14 @@
 import java.util.Collection;
 import java.util.Collections;
+import java.util.HashMap;
 import org.apache.wicket.request.mapper.parameter.PageParameters;
 import org.apache.wicket.markup.html.WebPage;
 import org.apache.wicket.model.Model;
 
+/**
+ * The main search page showing a search form, facets, and search results
+ *
+ * @author twagoo
+ */
 public class FacetedSearchPage extends WebPage {
 
@@ -17,5 +23,10 @@
 
         final QueryFacetsSelection selection = new QueryFacetsSelection(
-                Collections.<String, Collection<String>>singletonMap("language", Collections.singleton("Dutch")));
+                new HashMap<String, Collection<String>>() {
+                    {
+                        put("language", Collections.singleton("Dutch"));
+                        put("continent", Collections.<String>emptyList());
+                    }
+                });
 
         add(new FacetsPanel("facets", new Model<QueryFacetsSelection>(selection)));