Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/config/VloSpringConfig.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/config/VloSpringConfig.java	(revision 4529)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/config/VloSpringConfig.java	(revision 4530)
@@ -20,6 +20,8 @@
 import eu.clarin.cmdi.vlo.service.FacetFieldsService;
 import eu.clarin.cmdi.vlo.service.SearchResultsDao;
+import eu.clarin.cmdi.vlo.service.SolrDocumentService;
 import eu.clarin.cmdi.vlo.service.SolrQueryFactory;
 import eu.clarin.cmdi.vlo.service.impl.SearchResultsDaoImpl;
+import eu.clarin.cmdi.vlo.service.impl.SolrDocumentServiceImpl;
 import eu.clarin.cmdi.vlo.service.impl.SolrFacetFieldsService;
 import eu.clarin.cmdi.vlo.service.impl.SolrQueryFactoryImpl;
@@ -70,4 +72,9 @@
         return new SolrFacetFieldsService(searchResultsDao(), queryFactory());
     }
+    
+    @Bean
+    public SolrDocumentService documentService() {
+        return new SolrDocumentServiceImpl(searchResultsDao(), queryFactory());
+    }
 
     @Bean
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/SearchResultsDao.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/SearchResultsDao.java	(revision 4529)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/SearchResultsDao.java	(revision 4530)
@@ -29,5 +29,5 @@
 public interface SearchResultsDao {
 
-    SolrDocumentList getDocIdList(SolrQuery query);
+    SolrDocumentList getDocuments(SolrQuery query);
 
     List<FacetField> getFacets(SolrQuery query);
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/SolrDocumentService.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/SolrDocumentService.java	(revision 4530)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/SolrDocumentService.java	(revision 4530)
@@ -0,0 +1,33 @@
+/*
+ * Copyright (C) 2014 CLARIN
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+package eu.clarin.cmdi.vlo.service;
+
+import eu.clarin.cmdi.vlo.pojo.QueryFacetsSelection;
+import java.util.List;
+import org.apache.solr.common.SolrDocument;
+
+/**
+ *
+ * @author twagoo
+ */
+public interface SolrDocumentService {
+
+    List<SolrDocument> getDocuments(QueryFacetsSelection selection, int first, int count);
+    
+    long getDocumentCount(QueryFacetsSelection selection);
+
+}
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/SolrQueryFactory.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/SolrQueryFactory.java	(revision 4529)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/SolrQueryFactory.java	(revision 4530)
@@ -31,4 +31,6 @@
 
     SolrQuery createCountFacetsQuery();
+    
+    SolrQuery createDocumentQuery(QueryFacetsSelection selection, int first, int count);
 
 }
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/SearchResultsDaoImpl.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/SearchResultsDaoImpl.java	(revision 4529)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/SearchResultsDaoImpl.java	(revision 4530)
@@ -38,13 +38,9 @@
 
     @Override
-    public SolrDocumentList getDocIdList(SolrQuery query) {
-        query = query.getCopy();
-        setDefaultSortField(query);
-        query.setFields(FacetConstants.FIELD_ID);
-        query.setFacet(false);
-        query.setStart(0);
-        query.setRows(Integer.MAX_VALUE);
+    public SolrDocumentList getDocuments(SolrQuery query) {
         QueryResponse queryResponse = fireQuery(query);
-        return queryResponse.getResults();
+        final SolrDocumentList documents = queryResponse.getResults();
+        logger.debug("Found {} documents", documents.getNumFound());
+        return documents;
     }
 
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/SolrDocumentServiceImpl.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/SolrDocumentServiceImpl.java	(revision 4530)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/SolrDocumentServiceImpl.java	(revision 4530)
@@ -0,0 +1,55 @@
+/*
+ * Copyright (C) 2014 CLARIN
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+package eu.clarin.cmdi.vlo.service.impl;
+
+import eu.clarin.cmdi.vlo.pojo.QueryFacetsSelection;
+import eu.clarin.cmdi.vlo.service.SearchResultsDao;
+import eu.clarin.cmdi.vlo.service.SolrDocumentService;
+import eu.clarin.cmdi.vlo.service.SolrQueryFactory;
+import java.util.List;
+import org.apache.solr.client.solrj.SolrQuery;
+import org.apache.solr.common.SolrDocument;
+
+/**
+ *
+ * @author twagoo
+ */
+public class SolrDocumentServiceImpl implements SolrDocumentService {
+
+    private final SearchResultsDao searchResultsDao;
+    private final SolrQueryFactory queryFatory;
+
+    public SolrDocumentServiceImpl(SearchResultsDao searchResultsDao, SolrQueryFactory queryFatory) {
+        this.searchResultsDao = searchResultsDao;
+        this.queryFatory = queryFatory;
+    }
+
+    @Override
+    public List<SolrDocument> getDocuments(QueryFacetsSelection selection, int first, int count) {
+        //TODO: Use document query
+        SolrQuery query = queryFatory.createDocumentQuery(selection,first, count);
+        return searchResultsDao.getDocuments(query);
+    }
+
+    @Override
+    public long getDocumentCount(QueryFacetsSelection selection) {
+        //TODO: Use document query/count query?
+        SolrQuery query = queryFatory.createDocumentQuery(selection,0,0);
+        return searchResultsDao.getDocuments(query).getNumFound();
+    }
+
+}
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/SolrQueryFactoryImpl.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/SolrQueryFactoryImpl.java	(revision 4529)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/SolrQueryFactoryImpl.java	(revision 4530)
@@ -51,4 +51,18 @@
     public SolrQuery createFacetQuery(QueryFacetsSelection queryFacetsSelections) {
         final SolrQuery query = getDefaultFacetQuery();
+        addQueryFacetParameters(query, queryFacetsSelections);
+        return query;
+    }
+
+    @Override
+    public SolrQuery createDocumentQuery(QueryFacetsSelection selection, int first, int count) {
+        final SolrQuery query = getDefaultDocumentQuery();
+        addQueryFacetParameters(query, selection);
+        query.setStart(first);
+        query.setRows(count);
+        return query;
+    }
+
+    protected void addQueryFacetParameters(final SolrQuery query, QueryFacetsSelection queryFacetsSelections) {
         final String queryString = queryFacetsSelections.getQuery();
 
@@ -72,5 +86,4 @@
         }
         query.setFilterQueries(encodedQueries.toArray(new String[encodedQueries.size()]));
-        return query;
     }
 
@@ -86,4 +99,10 @@
     }
 
+    private SolrQuery getDefaultDocumentQuery() {
+        SolrQuery result = new SolrQuery();
+        result.setFields(FacetConstants.FIELD_NAME, FacetConstants.FIELD_ID, FacetConstants.FIELD_DESCRIPTION, FacetConstants.FIELD_COLLECTION, FacetConstants.FIELD_RESOURCE);
+        return result;
+    }
+
     @Override
     public synchronized SolrQuery createCountFacetsQuery() {
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/SearchResultsPanel.html
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/SearchResultsPanel.html	(revision 4530)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/SearchResultsPanel.html	(revision 4530)
@@ -0,0 +1,156 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
+<!--
+Copyright (C) 2014 CLARIN
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+-->
+<html xmlns="http://www.w3.org/1999/xhtml" xmlns:wicket="http://wicket.apache.org" xml:lang="en">
+    <head>
+        <title>facet panel</title>
+        <meta charset="UTF-8">
+    </head>
+    <body>
+        <wicket:panel>
+            <h1>Search results</h1>
+            <div id="searchresultsheader">
+                <span wicket:id="resultCount" id="searchresultcount">604056 results</span>
+                <span id="searchresultpagecount">Showing 1 to 25</span>
+
+                <div class="searchresultpagination">
+                    &lt;&lt;
+                    &lt;
+                    1
+                    <a href="">2</a>
+                    <a href="">3</a>
+                    <a href="">4</a>
+                    <a href="">5</a>
+                    <a href="">6</a>
+                    <a href="">7</a>
+                    <a href="">8</a>
+                    <a href="">9</a>
+                    <a href="">10</a>
+                    <a href="">&gt;</a>
+                    <a href="">&gt;&gt;</a>
+                </div>
+
+            </div> 
+
+            <ul id="searchresultitems">
+                <li wicket:id="resultItem" class="searchresultitem">
+                    <h2>
+                        <a wicket:id="title" href="record1.html">[TITLE]</a>
+                    </h2>
+                    <div class="searchresultitembrief">
+                        <p class="searchresultmoreless">
+                            <a href="#" class="searchresultdetailstoggle">expand</a>
+                        </p>
+                        <p class="searchresultdescription" wicket:id="description">
+                            [DESCRIPTION]
+                        </p>
+                        <p class="searchresultresources">
+                            Resources: <a href="record1.html">1 text file</a>, <a href="record1.html">1 audio file</a>, <a href="record1.html">1 annotation file</a>
+                        </p>
+                    </div>
+
+                    <div class="searchresultitemextended">
+                        <p class="searchresultmoreless">
+                            <a href="#" class="searchresultdetailstoggle">collapse</a>
+                        </p>
+                        <p class="searchresultdescription">
+                            In China (and specifically in Beijing) of the late seventies, the call for a democracy movement was growing ever stronger, before finally being silenced by the new regime under Deng Xiaoping. This paper exmaines both the historical sources and the eventual outcome of this movement during the anxious years of '78-'79.
+                        </p>
+                        <div class="searchresultattributes">
+                            <table class="recorddetailstable">
+                                <tbody class="attributesTbody">
+                                    <tr>
+                                        <td class="attribute">
+                                            <div>Collection</div>
+                                        </td><td class="attributeValue">
+                                            <div>UBU Clarin Set<a class="recordfacetselect" title="Search for similar" href="index2.html"><span>[search for similar]</span></a></div>
+                                        </td>
+                                    </tr>
+                                    <tr>
+                                        <td class="attribute">
+                                            <div>Genre</div>
+                                        </td><td class="attributeValue">
+                                            <div>info:eu-repo/semantics/bachelorthesis <a class="recordfacetselect" title="Search for similar" href="index2.html"><span>[search for similar]</span></a></div>
+                                        </td>
+                                    </tr><tr>
+                                        <td class="attribute">
+                                            <div>Languages</div>
+                                        </td><td class="attributeValue">
+                                            <div>Dutch <a class="recordattributeinfo" href="http://infra.clarin.eu/service/language/info.php?code=nld"><span>[info]</span></a> <a class="recordfacetselect" title="Search for similar" href="index2.html"><span>[search for similar]</span></a></div>
+                                        </td>
+                                    </tr><tr>
+                                        <td class="attribute">
+                                            <div>National project</div>
+                                        </td><td class="attributeValue">
+                                            <div>CLARIN-NL <a class="recordfacetselect" title="Search for similar" href="index2.html"><span>[search for similar]</span></a></div>
+                                        </td>
+                                    </tr><tr>
+                                        <td class="attribute">
+                                            <div>Resource type</div>
+                                        </td><td class="attributeValue">
+                                            <div>text <a class="recordfacetselect" title="Search for similar" href="index2.html"><span>[search for similar]</span></a></div>
+                                        </td>
+                                    </tr>
+                                </tbody>
+                            </table>
+
+                            <h3>Resources</h3>
+                            <ul>
+                                <li class="writtenresource"><a href="">http://dspace.library.uu.nl/bitstream/1874/235456/1/Bachelorscriptie+Rene+Witteveen+3375005.docx</a></li>
+                                <li class="audioresource"><a href="">http://corpus1.mpi.nl/qfs1/media-archive/dobes_data/Ache/Documentaci_n_-_Documentation/Comunidades_-_Communities/Cerro_Moroti/Media/002-djawu_klluu-2011-09-01.wav</a></li>
+                                <li class="annotationresource"><a href="">http://corpus1.mpi.nl/qfs1/media-archive/dobes_data/Ache/Documentaci_n_-_Documentation/Comunidades_-_Communities/Cerro_Moroti/Annotations/002-djawu_klluu-2011-09-01.eaf</a></li>
+                            </ul>
+                        </div>
+
+                        <p class="searchresultfullrecord">
+                            <a href="record1.html">View full record</a>
+                        </p>
+                    </div>
+                    <div class="searchresultitemend"></div>
+                </li>
+            </ul>
+            <div id="searchresultpagination">
+                &lt;&lt;
+                &lt;
+                1
+                <a href="">2</a>
+                <a href="">3</a>
+                <a href="">4</a>
+                <a href="">5</a>
+                <a href="">6</a>
+                <a href="">7</a>
+                <a href="">8</a>
+                <a href="">9</a>
+                <a href="">10</a>
+                <a href="">&gt;</a>
+                <a href="">&gt;&gt;</a>
+
+                <form id="resultpagesizeform">
+                    <label for="resultpagesize">Results per page:</label>
+                    <select id="resultpagesize">
+                        <option>5</option>
+                        <option>10</option>
+                        <option selected="selected">25</option>
+                        <option>50</option>
+                        <option>100</option>
+                    </select>
+                </form>
+            </div>
+        </wicket:panel>
+    </body>
+</html>
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/SearchResultsPanel.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/SearchResultsPanel.java	(revision 4530)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/SearchResultsPanel.java	(revision 4530)
@@ -0,0 +1,67 @@
+/*
+ * Copyright (C) 2014 CLARIN
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+package eu.clarin.cmdi.vlo.wicket.components;
+
+import eu.clarin.cmdi.vlo.FacetConstants;
+import eu.clarin.cmdi.vlo.pojo.QueryFacetsSelection;
+import eu.clarin.cmdi.vlo.service.SolrDocumentService;
+import eu.clarin.cmdi.vlo.wicket.provider.SolrDocumentProvider;
+import org.apache.solr.common.SolrDocument;
+import org.apache.wicket.markup.html.basic.Label;
+import org.apache.wicket.markup.html.navigation.paging.IPageable;
+import org.apache.wicket.markup.html.panel.Panel;
+import org.apache.wicket.markup.repeater.Item;
+import org.apache.wicket.markup.repeater.data.DataView;
+import org.apache.wicket.markup.repeater.data.IDataProvider;
+import org.apache.wicket.model.AbstractReadOnlyModel;
+import org.apache.wicket.model.IModel;
+import org.apache.wicket.spring.injection.annot.SpringBean;
+
+/**
+ *
+ * @author twagoo
+ */
+public class SearchResultsPanel extends Panel {
+
+    @SpringBean
+    private SolrDocumentService documentService;
+    private final IDataProvider<SolrDocument> solrDocumentProvider;
+
+    public SearchResultsPanel(String id, IModel<QueryFacetsSelection> model) {
+        super(id, model);
+        solrDocumentProvider = new SolrDocumentProvider(documentService, model);
+        add(new Label("resultCount", new AbstractReadOnlyModel<Long>() {
+
+            @Override
+            public Long getObject() {
+                return solrDocumentProvider.size();
+            }
+        }));
+        
+        add(new DataView<SolrDocument>("resultItem", solrDocumentProvider, 10) {
+
+            @Override
+            protected void populateItem(Item<SolrDocument> item) {
+                //TODO: get all values, show name
+                //TODO: create IModel impl that reads field values from a solr document
+                item.add(new Label("title", (String)item.getModelObject().getFieldValue(FacetConstants.FIELD_NAME)));
+                item.add(new Label("description", (String)item.getModelObject().getFieldValue(FacetConstants.FIELD_DESCRIPTION)));
+            }
+        });
+    }
+
+}
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/pages/FacetedSearchPage.html
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/pages/FacetedSearchPage.html	(revision 4529)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/pages/FacetedSearchPage.html	(revision 4530)
@@ -103,181 +103,11 @@
                     </p>
                 </form>
-                <div id="searchresults">
-                    <h1>Search results</h1>
-                    <div id="searchresultsheader">
-                        <span id="searchresultcount">604056 results</span>
-                        <span id="searchresultpagecount">Showing 1 to 25</span>
-
-                        <div class="searchresultpagination">
-                            &lt;&lt;
-                            &lt;
-                            1
-                            <a href="">2</a>
-                            <a href="">3</a>
-                            <a href="">4</a>
-                            <a href="">5</a>
-                            <a href="">6</a>
-                            <a href="">7</a>
-                            <a href="">8</a>
-                            <a href="">9</a>
-                            <a href="">10</a>
-                            <a href="">&gt;</a>
-                            <a href="">&gt;&gt;</a>
-                        </div>
-
-                    </div> 
-
-                    <ul id="searchresultitems">
-                        <li class="searchresultitem">
-                            <h2>
-                                <a href="record1.html">"Chinese Democratie en de Transformatie"</a>
-                            </h2>
-                            <div class="searchresultitembrief">
-                                <p class="searchresultmoreless">
-                                    <a href="#" class="searchresultdetailstoggle">expand</a>
-                                </p>
-                                <p class="searchresultdescription">
-                                    In China (and specifically in Beijing) of the late seventies, the call for a democracy movement was growing ever stronger, before finally being silenced by the new regime under Deng Xiaoping...
-                                </p>
-                                <p class="searchresultresources">
-                                    Resources: <a href="record1.html">1 text file</a>, <a href="record1.html">1 audio file</a>, <a href="record1.html">1 annotation file</a>
-                                </p>
-                            </div>
-
-                            <div class="searchresultitemextended">
-                                <p class="searchresultmoreless">
-                                    <a href="#" class="searchresultdetailstoggle">collapse</a>
-                                </p>
-                                <p class="searchresultdescription">
-                                    In China (and specifically in Beijing) of the late seventies, the call for a democracy movement was growing ever stronger, before finally being silenced by the new regime under Deng Xiaoping. This paper exmaines both the historical sources and the eventual outcome of this movement during the anxious years of '78-'79.
-                                </p>
-                                <div class="searchresultattributes">
-                                    <table class="recorddetailstable">
-                                        <tbody class="attributesTbody">
-                                            <tr>
-                                                <td class="attribute">
-                                                    <div>Collection</div>
-                                                </td><td class="attributeValue">
-                                                    <div>UBU Clarin Set<a class="recordfacetselect" title="Search for similar" href="index2.html"><span>[search for similar]</span></a></div>
-                                                </td>
-                                            </tr>
-                                            <tr>
-                                                <td class="attribute">
-                                                    <div>Genre</div>
-                                                </td><td class="attributeValue">
-                                                    <div>info:eu-repo/semantics/bachelorthesis <a class="recordfacetselect" title="Search for similar" href="index2.html"><span>[search for similar]</span></a></div>
-                                                </td>
-                                            </tr><tr>
-                                                <td class="attribute">
-                                                    <div>Languages</div>
-                                                </td><td class="attributeValue">
-                                                    <div>Dutch <a class="recordattributeinfo" href="http://infra.clarin.eu/service/language/info.php?code=nld"><span>[info]</span></a> <a class="recordfacetselect" title="Search for similar" href="index2.html"><span>[search for similar]</span></a></div>
-                                                </td>
-                                            </tr><tr>
-                                                <td class="attribute">
-                                                    <div>National project</div>
-                                                </td><td class="attributeValue">
-                                                    <div>CLARIN-NL <a class="recordfacetselect" title="Search for similar" href="index2.html"><span>[search for similar]</span></a></div>
-                                                </td>
-                                            </tr><tr>
-                                                <td class="attribute">
-                                                    <div>Resource type</div>
-                                                </td><td class="attributeValue">
-                                                    <div>text <a class="recordfacetselect" title="Search for similar" href="index2.html"><span>[search for similar]</span></a></div>
-                                                </td>
-                                            </tr>
-                                        </tbody>
-                                    </table>
-
-                                    <h3>Resources</h3>
-                                    <ul>
-                                        <li class="writtenresource"><a href="">http://dspace.library.uu.nl/bitstream/1874/235456/1/Bachelorscriptie+Rene+Witteveen+3375005.docx</a></li>
-                                        <li class="audioresource"><a href="">http://corpus1.mpi.nl/qfs1/media-archive/dobes_data/Ache/Documentaci_n_-_Documentation/Comunidades_-_Communities/Cerro_Moroti/Media/002-djawu_klluu-2011-09-01.wav</a></li>
-                                        <li class="annotationresource"><a href="">http://corpus1.mpi.nl/qfs1/media-archive/dobes_data/Ache/Documentaci_n_-_Documentation/Comunidades_-_Communities/Cerro_Moroti/Annotations/002-djawu_klluu-2011-09-01.eaf</a></li>
-                                    </ul>
-                                </div>
-
-                                <p class="searchresultfullrecord">
-                                    <a href="record1.html">View full record</a>
-                                </p>
-                            </div>
-                            <div class="searchresultitemend"></div>
-                        </li>
-                        <li class="searchresultitem">
-                            <h2>
-                                <a href="record1.html">"Zichzelf zien"': het dubbelgangermotief in E.T.A. Hoffmanns Prinzessin Brambilla. ein Capriccio nach Jacob Callot. Een Lacaniaanse analyse</a>
-                            </h2>
-                            <p class="searchresultmoreless">
-                                <a href="#" class="searchresultdetailstoggle">expand</a>
-                            </p>
-                            <p class="searchresultdescription">
-                                Mogelijke implicaties van het 'zichzelf zien'(zoals de vroege romanticus Jean Paul Richter het dubbelgangermotief benoemde), werkte E.T.A. Hoffmann uit in de experimentele tekst PRINZESSIN BRAMBILLA. Daarin verbindt de auteur...
-                            </p>
-                            <p class="searchresultresources">
-                                Resources: <a href="record1.html">1 text file</a>, <a href="record1.html">1 audio file</a>
-                            </p>
-                            <div class="searchresultitemend"></div>
-                        </li>
-                        <li class="searchresultitem">
-                            <h2>
-                                <a href="record1.html">2007 Festival</a>
-                            </h2>
-                            <p class="searchresultmoreless"><a href="#" class="searchresultdetailstoggle">expand</a></p>
-                            <p class="searchresultdescription">
-                                Video documentation of the "festival of folk songs and dances". One file consisting of the three original tapes concatenated.
-                            </p>
-                            <p class="searchresultresources">
-                                Resources: <a href="record1.html">1 text file</a>, <a href="record1.html">1 audio file</a>
-                            </p>
-                            <div class="searchresultitemend"></div>
-                        </li>
-                        <li class="searchresultitem">
-                            <h2>
-                                <a href="record1.html">...DE LEUGEN REGEERT...</a>
-                            </h2>
-                            <p class="searchresultmoreless"><a href="#" class="searchresultdetailstoggle">expand</a></p>
-                            <p class="searchresultdescription">
-                                Presentatie: Felix Meurders. Hij wordt bijgestaan door een Mediaraad, die gedurende het programma commentaar levert op de onderwerpen. Vaste onderdelen: deleugenregeert.nl en een media-analyse door Francisco van Jole. Serie...
-                            </p>
-                            <p class="searchresultresources">
-                                Resources: <a href="record1.html">1 annotation file</a>, <a href="record1.html">1 audio file</a>
-                            </p>
-                            <div class="searchresultitemend"></div>
-                        </li>
-                    </ul>
-                    <div id="searchresultpagination">
-                        &lt;&lt;
-                        &lt;
-                        1
-                        <a href="">2</a>
-                        <a href="">3</a>
-                        <a href="">4</a>
-                        <a href="">5</a>
-                        <a href="">6</a>
-                        <a href="">7</a>
-                        <a href="">8</a>
-                        <a href="">9</a>
-                        <a href="">10</a>
-                        <a href="">&gt;</a>
-                        <a href="">&gt;&gt;</a>
-
-                        <form id="resultpagesizeform">
-                            <label for="resultpagesize">Results per page:</label>
-                            <select id="resultpagesize">
-                                <option>5</option>
-                                <option>10</option>
-                                <option selected="selected">25</option>
-                                <option>50</option>
-                                <option>100</option>
-                            </select>
-                        </form>
-                    </div>
-                </div>
+                <div wicket:id="searchResults" id="searchresults">[SEARCH RESULTS]</div>
             </div>
 
             <div class="sidebar">
-                
+
                 <div wicket:id="facets"></div>
-                
+
                 <div class="sidebaritem facet collapsedfacet">
                     <!-- rounded corners - top **** -->
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/pages/FacetedSearchPage.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/pages/FacetedSearchPage.java	(revision 4529)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/pages/FacetedSearchPage.java	(revision 4530)
@@ -4,4 +4,5 @@
 import eu.clarin.cmdi.vlo.pojo.QueryFacetsSelection;
 import eu.clarin.cmdi.vlo.wicket.components.SearchForm;
+import eu.clarin.cmdi.vlo.wicket.components.SearchResultsPanel;
 import java.util.Collection;
 import java.util.Collections;
@@ -35,4 +36,6 @@
         
         add(new SearchForm("search", queryModel));
+        
+        add(new SearchResultsPanel("searchResults", queryModel));
     }
 }
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/provider/SolrDocumentProvider.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/provider/SolrDocumentProvider.java	(revision 4530)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/provider/SolrDocumentProvider.java	(revision 4530)
@@ -0,0 +1,66 @@
+/*
+ * Copyright (C) 2014 CLARIN
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+package eu.clarin.cmdi.vlo.wicket.provider;
+
+import eu.clarin.cmdi.vlo.pojo.QueryFacetsSelection;
+import eu.clarin.cmdi.vlo.service.SolrDocumentService;
+import java.math.BigDecimal;
+import java.util.Iterator;
+import java.util.List;
+import org.apache.solr.common.SolrDocument;
+import org.apache.wicket.markup.repeater.data.IDataProvider;
+import org.apache.wicket.model.IModel;
+import org.apache.wicket.model.Model;
+import org.apache.wicket.util.convert.converter.BigDecimalConverter;
+
+/**
+ *
+ * @author twagoo
+ */
+public class SolrDocumentProvider implements IDataProvider<SolrDocument> {
+
+    private final SolrDocumentService documentService;
+    private final IModel<QueryFacetsSelection> selection;
+
+    public SolrDocumentProvider(SolrDocumentService documentService, IModel<QueryFacetsSelection> selection) {
+        this.documentService = documentService;
+        this.selection = selection;
+    }
+
+    @Override
+    public Iterator<? extends SolrDocument> iterator(long first, long count) {
+        final List<SolrDocument> documents = documentService.getDocuments(selection.getObject(),
+                BigDecimal.valueOf(first).intValueExact(), // safe long->int conversion
+                BigDecimal.valueOf(count).intValueExact()); // safe long->int conversion
+        return documents.iterator();
+    }
+
+    @Override
+    public long size() {
+        return documentService.getDocumentCount(selection.getObject());
+    }
+
+    @Override
+    public IModel<SolrDocument> model(SolrDocument object) {
+        return new Model(object);
+    }
+
+    @Override
+    public void detach() {
+    }
+
+}
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/test/java/eu/clarin/cmdi/vlo/wicket/pages/TestFacetedSearchPage.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/test/java/eu/clarin/cmdi/vlo/wicket/pages/TestFacetedSearchPage.java	(revision 4529)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/test/java/eu/clarin/cmdi/vlo/wicket/pages/TestFacetedSearchPage.java	(revision 4530)
@@ -6,7 +6,9 @@
 import eu.clarin.cmdi.vlo.pojo.QueryFacetsSelection;
 import eu.clarin.cmdi.vlo.service.FacetFieldsService;
+import eu.clarin.cmdi.vlo.service.SolrDocumentService;
 import java.util.Arrays;
 import java.util.List;
 import org.apache.solr.client.solrj.response.FacetField;
+import org.apache.solr.common.SolrDocument;
 import org.apache.wicket.util.tester.WicketTester;
 import org.jmock.Expectations;
@@ -50,4 +52,8 @@
         }
 
+        @Override
+        public SolrDocumentService documentService() {
+            return mockery().mock(SolrDocumentService.class);
+        }
     }
 
@@ -59,4 +65,6 @@
     @Autowired
     private FacetFieldsService facetFieldsService;
+    @Autowired
+    private SolrDocumentService documentService;
 
     @Before
@@ -70,8 +78,15 @@
         mockery.checking(new Expectations() {
             {
+                // mock facets
                 atLeast(1).of(facetFieldsService).getFacetFieldCount();
                 will(returnValue(2L));
                 oneOf(facetFieldsService).getFacetFields(with(any(QueryFacetsSelection.class)));
                 will(returnValue(Arrays.asList(new FacetField("language"), new FacetField("resource class"))));
+                
+                // mock search results
+                atLeast(1).of(documentService).getDocumentCount(with(any(QueryFacetsSelection.class)));
+                will(returnValue(1000L));
+                oneOf(documentService).getDocuments(with(any(QueryFacetsSelection.class)), with(equal(0)), with(equal(10)));
+                will(returnValue(Arrays.asList(new SolrDocument(), new SolrDocument())));
             }
         });