Index: o/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/FacetPanel.html
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/FacetPanel.html	(revision 4537)
+++ 	(revision )
@@ -1,43 +1,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
-<!--
-Copyright (C) 2014 CLARIN
-
-This program is free software: you can redistribute it and/or modify
-it under the terms of the GNU General Public License as published by
-the Free Software Foundation, either version 3 of the License, or
-(at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program.  If not, see <http://www.gnu.org/licenses/>.
--->
-<html xmlns="http://www.w3.org/1999/xhtml" xmlns:wicket="http://wicket.apache.org" xml:lang="en">
-    <head>
-        <title>facet panel</title>
-        <meta charset="UTF-8">
-    </head>
-    <body>
-    <wicket:panel>
-        <div class="facet collapsedfacet">
-            <a href="#" class="expandfacet"><span>expand</span></a>
-            <a href="#" class="collapsefacet"><span>collapse</span></a>
-            <h1><a href="#"><wicket:container wicket:id="name">[TITLE]</wicket:container></a></h1>
-            <a href class="filtertoggle"><span>filter</span></a>
-            <form class="filterform">
-                <input type="text" />
-            </form>
-            <div class="sbilinks facetvalues">
-                <ul>
-                    <li wicket:id="facetValues"><a wicket:id="facetSelect" href="index3.html"><span wicket:id="name">Dutch</span> (<span wicket:id="count">148167</span>)</a></li>
-                    <!--<li class="more-link"><a wicket:id="allFacetValuesLink" href="#">more...</a></li>-->
-                </ul>
-            </div>
-        </div>
-    </wicket:panel>
-</body>
-</html>
Index: o/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/FacetPanel.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/FacetPanel.java	(revision 4537)
+++ 	(revision )
@@ -1,86 +1,0 @@
-/*
- * Copyright (C) 2014 CLARIN
- *
- * This program is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program.  If not, see <http://www.gnu.org/licenses/>.
- */
-package eu.clarin.cmdi.vlo.wicket.components;
-
-import eu.clarin.cmdi.vlo.wicket.provider.FacetFieldValuesProvider;
-import java.util.Collection;
-import java.util.Collections;
-import org.apache.solr.client.solrj.response.FacetField;
-import org.apache.solr.client.solrj.response.FacetField.Count;
-import org.apache.wicket.ajax.AjaxRequestTarget;
-import org.apache.wicket.ajax.markup.html.AjaxFallbackLink;
-import org.apache.wicket.markup.html.basic.Label;
-import org.apache.wicket.markup.html.link.Link;
-import org.apache.wicket.markup.html.panel.Panel;
-import org.apache.wicket.markup.repeater.Item;
-import org.apache.wicket.markup.repeater.data.DataView;
-import org.apache.wicket.model.CompoundPropertyModel;
-import org.apache.wicket.model.IModel;
-
-/**
- * A panel representing a single facet
- *
- * @author twagoo
- */
-public abstract class FacetPanel extends Panel {
-
-    private final int maxNumberOfFacetsToShow = 10; //TODO: get from config
-
-    public FacetPanel(String id, IModel<FacetField> model) {
-        super(id, model);
-        setDefaultModel(new CompoundPropertyModel<FacetField>(model));
-
-        // 'name' field from FacetField
-        add(new Label("name"));
-
-        // provider that extracts values and counts from FacetField
-        final FacetFieldValuesProvider valuesProvider = new FacetFieldValuesProvider(model, maxNumberOfFacetsToShow);
-        add(new DataView<Count>("facetValues", valuesProvider) {
-
-            @Override
-            protected void populateItem(final Item<Count> item) {
-                item.setDefaultModel(new CompoundPropertyModel<Count>(item.getModel()));
-                final Link selectLink = new AjaxFallbackLink("facetSelect") {
-
-                    @Override
-                    public void onClick(AjaxRequestTarget target) {
-                        FacetPanel.this.onValuesSelected(
-                                item.getModelObject().getFacetField().getName(),
-                                Collections.singleton(item.getModelObject().getName()),
-                                target);
-                    }
-                };
-                item.add(selectLink);
-                // 'name' field from Count (name of value)
-                selectLink.add(new Label("name"));
-                // 'count' field from Count (document count for value)
-                selectLink.add(new Label("count"));
-            }
-        });
-    }
-
-    /**
-     * Callback triggered when values have been selected on this facet
-     *
-     * @param facet name of the facet this panel represents
-     * @param values selected values
-     * @param target Ajax target allowing for a partial update. May be null
-     * (fallback)!
-     */
-    public abstract void onValuesSelected(String facet, Collection<String> values, AjaxRequestTarget target);
-
-}
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/FacetValuesPanel.html
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/FacetValuesPanel.html	(revision 4538)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/FacetValuesPanel.html	(revision 4538)
@@ -0,0 +1,43 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
+<!--
+Copyright (C) 2014 CLARIN
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+-->
+<html xmlns="http://www.w3.org/1999/xhtml" xmlns:wicket="http://wicket.apache.org" xml:lang="en">
+    <head>
+        <title>facet panel</title>
+        <meta charset="UTF-8">
+    </head>
+    <body>
+    <wicket:panel>
+        <div class="facet collapsedfacet">
+            <a href="#" class="expandfacet"><span>expand</span></a>
+            <a href="#" class="collapsefacet"><span>collapse</span></a>
+            <h1><a href="#"><wicket:container wicket:id="name">[TITLE]</wicket:container></a></h1>
+            <a href class="filtertoggle"><span>filter</span></a>
+            <form class="filterform">
+                <input type="text" />
+            </form>
+            <div class="sbilinks facetvalues">
+                <ul>
+                    <li wicket:id="facetValues"><a wicket:id="facetSelect" href="index3.html"><span wicket:id="name">Dutch</span> (<span wicket:id="count">148167</span>)</a></li>
+                    <!--<li class="more-link"><a wicket:id="allFacetValuesLink" href="#">more...</a></li>-->
+                </ul>
+            </div>
+        </div>
+    </wicket:panel>
+</body>
+</html>
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/FacetValuesPanel.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/FacetValuesPanel.java	(revision 4538)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/FacetValuesPanel.java	(revision 4538)
@@ -0,0 +1,86 @@
+/*
+ * Copyright (C) 2014 CLARIN
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+package eu.clarin.cmdi.vlo.wicket.components;
+
+import eu.clarin.cmdi.vlo.wicket.provider.FacetFieldValuesProvider;
+import java.util.Collection;
+import java.util.Collections;
+import org.apache.solr.client.solrj.response.FacetField;
+import org.apache.solr.client.solrj.response.FacetField.Count;
+import org.apache.wicket.ajax.AjaxRequestTarget;
+import org.apache.wicket.ajax.markup.html.AjaxFallbackLink;
+import org.apache.wicket.markup.html.basic.Label;
+import org.apache.wicket.markup.html.link.Link;
+import org.apache.wicket.markup.html.panel.Panel;
+import org.apache.wicket.markup.repeater.Item;
+import org.apache.wicket.markup.repeater.data.DataView;
+import org.apache.wicket.model.CompoundPropertyModel;
+import org.apache.wicket.model.IModel;
+
+/**
+ * A panel representing a single facet
+ *
+ * @author twagoo
+ */
+public abstract class FacetValuesPanel extends Panel {
+
+    private final int maxNumberOfFacetsToShow = 10; //TODO: get from config
+
+    public FacetValuesPanel(String id, IModel<FacetField> model) {
+        super(id, model);
+        setDefaultModel(new CompoundPropertyModel<FacetField>(model));
+
+        // 'name' field from FacetField
+        add(new Label("name"));
+
+        // provider that extracts values and counts from FacetField
+        final FacetFieldValuesProvider valuesProvider = new FacetFieldValuesProvider(model, maxNumberOfFacetsToShow);
+        add(new DataView<Count>("facetValues", valuesProvider) {
+
+            @Override
+            protected void populateItem(final Item<Count> item) {
+                item.setDefaultModel(new CompoundPropertyModel<Count>(item.getModel()));
+                final Link selectLink = new AjaxFallbackLink("facetSelect") {
+
+                    @Override
+                    public void onClick(AjaxRequestTarget target) {
+                        FacetValuesPanel.this.onValuesSelected(
+                                item.getModelObject().getFacetField().getName(),
+                                Collections.singleton(item.getModelObject().getName()),
+                                target);
+                    }
+                };
+                item.add(selectLink);
+                // 'name' field from Count (name of value)
+                selectLink.add(new Label("name"));
+                // 'count' field from Count (document count for value)
+                selectLink.add(new Label("count"));
+            }
+        });
+    }
+
+    /**
+     * Callback triggered when values have been selected on this facet
+     *
+     * @param facet name of the facet this panel represents
+     * @param values selected values
+     * @param target Ajax target allowing for a partial update. May be null
+     * (fallback)!
+     */
+    public abstract void onValuesSelected(String facet, Collection<String> values, AjaxRequestTarget target);
+
+}
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/FacetsPanel.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/FacetsPanel.java	(revision 4537)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/FacetsPanel.java	(revision 4538)
@@ -46,5 +46,5 @@
             @Override
             protected void populateItem(Item<FacetField> item) {
-                item.add(new FacetPanel("facet", item.getModel()) {
+                item.add(new FacetValuesPanel("facet", item.getModel()) {
 
                     @Override