Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/pojo/QueryFacetsSelection.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/pojo/QueryFacetsSelection.java	(revision 4542)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/pojo/QueryFacetsSelection.java	(revision 4543)
@@ -20,4 +20,5 @@
 import java.util.Collection;
 import java.util.Collections;
+import java.util.HashMap;
 import java.util.Map;
 
@@ -51,10 +52,14 @@
      * Creates a selection with a textual query and facet value selection
      *
-     * @param query textual query
-     * @param selection facet values selection map
+     * @param query textual query (can be null)
+     * @param selection facet values selection map (can be null)
      */
     public QueryFacetsSelection(String query, Map<String, Collection<String>> selection) {
         this.queryString = query;
-        this.selection = selection;
+        if (selection == null) {
+            this.selection = new HashMap<String, Collection<String>>();
+        } else {
+            this.selection = selection;
+        }
     }
 
@@ -95,6 +100,6 @@
         this.queryString = queryString;
     }
-    
-    public void selectValues(String facet, Collection<String> values){
+
+    public void selectValues(String facet, Collection<String> values) {
         selection.put(facet, values);
     }
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/SolrQueryFactoryImpl.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/SolrQueryFactoryImpl.java	(revision 4542)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/SolrQueryFactoryImpl.java	(revision 4543)
@@ -75,15 +75,17 @@
         Map<String, Collection<String>> selections = queryFacetsSelections.getSelection();
 
-        final List<String> encodedQueries = new ArrayList(selections.size()); // assuming every facet has one selection, most common scenario
-        for (Map.Entry<String, Collection<String>> selection : selections.entrySet()) {
-            final String facetName = selection.getKey();
-            final Collection<String> values = selection.getValue();
-            if (values != null) {
-                for (String value : values) {
-                    encodedQueries.add(String.format("%s:%s", facetName, ClientUtils.escapeQueryChars(value)));
+        if (selections != null) {
+            final List<String> encodedQueries = new ArrayList(selections.size()); // assuming every facet has one selection, most common scenario
+            for (Map.Entry<String, Collection<String>> selection : selections.entrySet()) {
+                final String facetName = selection.getKey();
+                final Collection<String> values = selection.getValue();
+                if (values != null) {
+                    for (String value : values) {
+                        encodedQueries.add(String.format("%s:%s", facetName, ClientUtils.escapeQueryChars(value)));
+                    }
                 }
             }
+            query.setFilterQueries(encodedQueries.toArray(new String[encodedQueries.size()]));
         }
-        query.setFilterQueries(encodedQueries.toArray(new String[encodedQueries.size()]));
     }
 
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/pages/FacetedSearchPage.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/pages/FacetedSearchPage.java	(revision 4542)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/pages/FacetedSearchPage.java	(revision 4543)
@@ -6,6 +6,5 @@
 import eu.clarin.cmdi.vlo.wicket.components.SearchResultsPanel;
 import java.util.Collection;
-import java.util.Collections;
-import java.util.HashMap;
+import java.util.Map;
 import org.apache.wicket.request.mapper.parameter.PageParameters;
 import org.apache.wicket.markup.html.WebPage;
@@ -24,18 +23,21 @@
         super(parameters);
 
-        final QueryFacetsSelection selection = new QueryFacetsSelection(
-                new HashMap<String, Collection<String>>() {
-                    {
-//                        put("language", Collections.singleton("Dutch"));
-                        put("continent", Collections.<String>emptyList());
-                    }
-                });
+        final QueryFacetsSelection selection = paramsToQueryFacetSelection(parameters);
         final Model<QueryFacetsSelection> queryModel = new Model<QueryFacetsSelection>(selection);
 
         add(new FacetsPanel("facets", queryModel));
-        
+
         add(new SearchForm("search", queryModel));
-        
+
         add(new SearchResultsPanel("searchResults", queryModel));
     }
+
+    private QueryFacetsSelection paramsToQueryFacetSelection(final PageParameters parameters) {
+        final String query = parameters.get("q").toOptionalString();
+        
+        //TODO: Map parameters to facet selection
+        final Map<String, Collection<String>> selection = null;
+        
+        return new QueryFacetsSelection(query, selection);
+    }
 }