Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/SearchResultItemPanel.html
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/SearchResultItemPanel.html	(revision 4560)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/SearchResultItemPanel.html	(revision 4560)
@@ -0,0 +1,101 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
+<!--
+Copyright (C) 2014 CLARIN
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+-->
+<html xmlns="http://www.w3.org/1999/xhtml" xmlns:wicket="http://wicket.apache.org" xml:lang="en">
+    <head>
+        <title>facet panel</title>
+        <meta charset="UTF-8">
+    </head>
+    <body>
+        <wicket:panel>
+            <h2>
+                <a wicket:id="title" href="record1.html">[TITLE]</a>
+            </h2>
+            <div class="searchresultitembrief">
+                <p class="searchresultmoreless">
+                    <a href="#" class="searchresultdetailstoggle">expand</a>
+                </p>
+                <p class="searchresultdescription" wicket:id="description">
+                    [DESCRIPTION]
+                </p>
+                <p class="searchresultresources">
+                    Resources: <a href="record1.html">1 text file</a>, <a href="record1.html">1 audio file</a>, <a href="record1.html">1 annotation file</a>
+                </p>
+            </div>
+<!--
+            <div class="searchresultitemextended">
+                <p class="searchresultmoreless">
+                    <a href="#" class="searchresultdetailstoggle">collapse</a>
+                </p>
+                <p class="searchresultdescription">
+                    In China (and specifically in Beijing) of the late seventies, the call for a democracy movement was growing ever stronger, before finally being silenced by the new regime under Deng Xiaoping. This paper exmaines both the historical sources and the eventual outcome of this movement during the anxious years of '78-'79.
+                </p>
+                <div class="searchresultattributes">
+                    <table class="recorddetailstable">
+                        <tbody class="attributesTbody">
+                            <tr>
+                                <td class="attribute">
+                                    <div>Collection</div>
+                                </td><td class="attributeValue">
+                                    <div>UBU Clarin Set<a class="recordfacetselect" title="Search for similar" href="index2.html"><span>[search for similar]</span></a></div>
+                                </td>
+                            </tr>
+                            <tr>
+                                <td class="attribute">
+                                    <div>Genre</div>
+                                </td><td class="attributeValue">
+                                    <div>info:eu-repo/semantics/bachelorthesis <a class="recordfacetselect" title="Search for similar" href="index2.html"><span>[search for similar]</span></a></div>
+                                </td>
+                            </tr><tr>
+                                <td class="attribute">
+                                    <div>Languages</div>
+                                </td><td class="attributeValue">
+                                    <div>Dutch <a class="recordattributeinfo" href="http://infra.clarin.eu/service/language/info.php?code=nld"><span>[info]</span></a> <a class="recordfacetselect" title="Search for similar" href="index2.html"><span>[search for similar]</span></a></div>
+                                </td>
+                            </tr><tr>
+                                <td class="attribute">
+                                    <div>National project</div>
+                                </td><td class="attributeValue">
+                                    <div>CLARIN-NL <a class="recordfacetselect" title="Search for similar" href="index2.html"><span>[search for similar]</span></a></div>
+                                </td>
+                            </tr><tr>
+                                <td class="attribute">
+                                    <div>Resource type</div>
+                                </td><td class="attributeValue">
+                                    <div>text <a class="recordfacetselect" title="Search for similar" href="index2.html"><span>[search for similar]</span></a></div>
+                                </td>
+                            </tr>
+                        </tbody>
+                    </table>
+
+                    <h3>Resources</h3>
+                    <ul>
+                        <li class="writtenresource"><a href="">http://dspace.library.uu.nl/bitstream/1874/235456/1/Bachelorscriptie+Rene+Witteveen+3375005.docx</a></li>
+                        <li class="audioresource"><a href="">http://corpus1.mpi.nl/qfs1/media-archive/dobes_data/Ache/Documentaci_n_-_Documentation/Comunidades_-_Communities/Cerro_Moroti/Media/002-djawu_klluu-2011-09-01.wav</a></li>
+                        <li class="annotationresource"><a href="">http://corpus1.mpi.nl/qfs1/media-archive/dobes_data/Ache/Documentaci_n_-_Documentation/Comunidades_-_Communities/Cerro_Moroti/Annotations/002-djawu_klluu-2011-09-01.eaf</a></li>
+                    </ul>
+                </div>
+
+                <p class="searchresultfullrecord">
+                    <a href="record1.html">View full record</a>
+                </p>
+            </div>-->
+            <div class="searchresultitemend"></div>
+        </wicket:panel>
+    </body>
+</html>
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/SearchResultItemPanel.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/SearchResultItemPanel.java	(revision 4560)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/SearchResultItemPanel.java	(revision 4560)
@@ -0,0 +1,53 @@
+/*
+ * Copyright (C) 2014 CLARIN
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+package eu.clarin.cmdi.vlo.wicket.components;
+
+import eu.clarin.cmdi.vlo.FacetConstants;
+import eu.clarin.cmdi.vlo.wicket.model.NullFallbackModel;
+import eu.clarin.cmdi.vlo.wicket.model.SolrFieldModel;
+import org.apache.solr.common.SolrDocument;
+import org.apache.wicket.markup.html.basic.Label;
+import org.apache.wicket.markup.html.panel.Panel;
+import org.apache.wicket.model.IModel;
+
+/**
+ *
+ * @author twagoo
+ */
+public class SearchResultItemPanel extends Panel {
+
+    public SearchResultItemPanel(String id, IModel<SolrDocument> model) {
+        super(id, model);
+        add(new SolrFieldLabel("title", model, FacetConstants.FIELD_NAME));
+        add(new SolrFieldLabel("description", model, FacetConstants.FIELD_DESCRIPTION, "<no description>"));
+    }
+
+
+    public static class SolrFieldLabel extends Label {
+
+        public SolrFieldLabel(String id, IModel<SolrDocument> documentModel, String fieldName) {
+            super(id, new SolrFieldModel(documentModel, fieldName));
+        }
+
+        public SolrFieldLabel(String id, IModel<SolrDocument> documentModel, String fieldName, String nullFallback) {
+            super(id,
+                    new NullFallbackModel(
+                            new SolrFieldModel(documentModel, fieldName), nullFallback));
+        }
+
+    }
+}
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/SearchResultsPanel.html
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/SearchResultsPanel.html	(revision 4559)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/SearchResultsPanel.html	(revision 4560)
@@ -25,91 +25,19 @@
         <wicket:panel>
             <h1>Search results</h1>
+            
             <div id="searchresultsheader">
                 <span wicket:id="resultCount" id="searchresultcount">604056 results</span>
                 <span wicket:id="resultPageIndicator" id="searchresultpagecount">Showing 1 to 25</span>
-
                 <div class="searchresultpagination">
                     <div wicket:id="pagingTop">[PAGING]</div>
                 </div>
-
             </div> 
 
             <ul id="searchresultitems">
                 <li wicket:id="resultItem" class="searchresultitem">
-                    <h2>
-                        <a wicket:id="title" href="record1.html">[TITLE]</a>
-                    </h2>
-                    <div class="searchresultitembrief">
-                        <p class="searchresultmoreless">
-                            <a href="#" class="searchresultdetailstoggle">expand</a>
-                        </p>
-                        <p class="searchresultdescription" wicket:id="description">
-                            [DESCRIPTION]
-                        </p>
-                        <p class="searchresultresources">
-                            Resources: <a href="record1.html">1 text file</a>, <a href="record1.html">1 audio file</a>, <a href="record1.html">1 annotation file</a>
-                        </p>
-                    </div>
-
-                    <div class="searchresultitemextended">
-                        <p class="searchresultmoreless">
-                            <a href="#" class="searchresultdetailstoggle">collapse</a>
-                        </p>
-                        <p class="searchresultdescription">
-                            In China (and specifically in Beijing) of the late seventies, the call for a democracy movement was growing ever stronger, before finally being silenced by the new regime under Deng Xiaoping. This paper exmaines both the historical sources and the eventual outcome of this movement during the anxious years of '78-'79.
-                        </p>
-                        <div class="searchresultattributes">
-                            <table class="recorddetailstable">
-                                <tbody class="attributesTbody">
-                                    <tr>
-                                        <td class="attribute">
-                                            <div>Collection</div>
-                                        </td><td class="attributeValue">
-                                            <div>UBU Clarin Set<a class="recordfacetselect" title="Search for similar" href="index2.html"><span>[search for similar]</span></a></div>
-                                        </td>
-                                    </tr>
-                                    <tr>
-                                        <td class="attribute">
-                                            <div>Genre</div>
-                                        </td><td class="attributeValue">
-                                            <div>info:eu-repo/semantics/bachelorthesis <a class="recordfacetselect" title="Search for similar" href="index2.html"><span>[search for similar]</span></a></div>
-                                        </td>
-                                    </tr><tr>
-                                        <td class="attribute">
-                                            <div>Languages</div>
-                                        </td><td class="attributeValue">
-                                            <div>Dutch <a class="recordattributeinfo" href="http://infra.clarin.eu/service/language/info.php?code=nld"><span>[info]</span></a> <a class="recordfacetselect" title="Search for similar" href="index2.html"><span>[search for similar]</span></a></div>
-                                        </td>
-                                    </tr><tr>
-                                        <td class="attribute">
-                                            <div>National project</div>
-                                        </td><td class="attributeValue">
-                                            <div>CLARIN-NL <a class="recordfacetselect" title="Search for similar" href="index2.html"><span>[search for similar]</span></a></div>
-                                        </td>
-                                    </tr><tr>
-                                        <td class="attribute">
-                                            <div>Resource type</div>
-                                        </td><td class="attributeValue">
-                                            <div>text <a class="recordfacetselect" title="Search for similar" href="index2.html"><span>[search for similar]</span></a></div>
-                                        </td>
-                                    </tr>
-                                </tbody>
-                            </table>
-
-                            <h3>Resources</h3>
-                            <ul>
-                                <li class="writtenresource"><a href="">http://dspace.library.uu.nl/bitstream/1874/235456/1/Bachelorscriptie+Rene+Witteveen+3375005.docx</a></li>
-                                <li class="audioresource"><a href="">http://corpus1.mpi.nl/qfs1/media-archive/dobes_data/Ache/Documentaci_n_-_Documentation/Comunidades_-_Communities/Cerro_Moroti/Media/002-djawu_klluu-2011-09-01.wav</a></li>
-                                <li class="annotationresource"><a href="">http://corpus1.mpi.nl/qfs1/media-archive/dobes_data/Ache/Documentaci_n_-_Documentation/Comunidades_-_Communities/Cerro_Moroti/Annotations/002-djawu_klluu-2011-09-01.eaf</a></li>
-                            </ul>
-                        </div>
-
-                        <p class="searchresultfullrecord">
-                            <a href="record1.html">View full record</a>
-                        </p>
-                    </div>
-                    <div class="searchresultitemend"></div>
+                    <wicket:container wicket:id="resultItemDetails" />
                 </li>
             </ul>
+            
             <div id="searchresultpagination">
                 <div wicket:id="pagingBottom">[PAGING]</div>
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/SearchResultsPanel.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/SearchResultsPanel.java	(revision 4559)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/SearchResultsPanel.java	(revision 4560)
@@ -55,10 +55,19 @@
     private final IDataProvider<SolrDocument> solrDocumentProvider;
     private final DataView<SolrDocument> resultsView;
-    
+
     public SearchResultsPanel(String id, IModel<QueryFacetsSelection> model) {
         super(id, model);
         solrDocumentProvider = new SolrDocumentProvider(documentService, model);
-        
-        add(resultsView = createResultsView("resultItem"));
+
+        // data view for search results
+        resultsView = new DataView<SolrDocument>("resultItem", solrDocumentProvider, 10) {
+
+            @Override
+            protected void populateItem(Item<SolrDocument> item) {
+                // single result item
+                item.add(new SearchResultItemPanel("resultItemDetails", item.getModel()));
+            }
+        };
+        add(resultsView);
 
         // pagination navigators
@@ -79,4 +88,7 @@
     }
 
+    /**
+     * Gets called on each request before render
+     */
     @Override
     protected void onConfigure() {
@@ -85,17 +97,4 @@
         this.get("pagingTop").setVisible(showPaging);
         this.get("pagingBottom").setVisible(showPaging);
-    }
-
-    private DataView<SolrDocument> createResultsView(String id) {
-        return new DataView<SolrDocument>(id, solrDocumentProvider, 10) {
-
-            @Override
-            protected void populateItem(Item<SolrDocument> item) {
-                final IModel<SolrDocument> documentModel = item.getModel();
-                item.add(new SolrFieldLabel("title", documentModel, FacetConstants.FIELD_NAME));
-                item.add(new SolrFieldLabel("description", documentModel, FacetConstants.FIELD_DESCRIPTION, "<no description>"));
-                //TODO: get resource information
-            }
-        };
     }
 
@@ -144,17 +143,3 @@
     }
 
-    public static class SolrFieldLabel extends Label {
-
-        public SolrFieldLabel(String id, IModel<SolrDocument> documentModel, String fieldName) {
-            super(id, new SolrFieldModel(documentModel, fieldName));
-        }
-
-        public SolrFieldLabel(String id, IModel<SolrDocument> documentModel, String fieldName, String nullFallback) {
-            super(id,
-                    new NullFallbackModel(
-                            new SolrFieldModel(documentModel, fieldName), nullFallback));
-        }
-
-    }
-
 }
Index: /vlo/branches/vlo-3.0/vlo-web-app/src/main/webapp/js/vlo-search.js
===================================================================
--- /vlo/branches/vlo-3.0/vlo-web-app/src/main/webapp/js/vlo-search.js	(revision 4559)
+++ /vlo/branches/vlo-3.0/vlo-web-app/src/main/webapp/js/vlo-search.js	(revision 4560)
@@ -18,11 +18,11 @@
 
 $(document).ready(function() {
-    $(".searchresultitemextended").hide();
+//    $(".searchresultitemextended").hide();
     
     $("a.searchresultdetailstoggle").click(function(event) {
         event.preventDefault();
-        var item = $(this).parents(".searchresultitem");
-        item.find(".searchresultitembrief").toggle();
-        item.find(".searchresultitemextended").toggle();
+//        var item = $(this).parents(".searchresultitem");
+//        item.find(".searchresultitembrief").toggle();
+//        item.find(".searchresultitemextended").toggle();
     });
 });