Index: /vlo/branches/vlo-3.0/vlo-commons/src/main/resources/facetConcepts.xml
===================================================================
--- /vlo/branches/vlo-3.0/vlo-commons/src/main/resources/facetConcepts.xml	(revision 4574)
+++ /vlo/branches/vlo-3.0/vlo-commons/src/main/resources/facetConcepts.xml	(revision 4575)
@@ -94,4 +94,6 @@
     <concept>http://www.isocat.org/datcat/DC-5361</concept> <!-- language usage (TEI) -->
     <concept>http://www.isocat.org/datcat/DC-5358</concept> <!--language (TEI) - MENZO: added for CLARIN-DK -->
+    
+    <concept>http://purl.org/dc/terms/language</concept>
    <!-- Had to be removed due to IDSAGD_Speaker  <acceptableContext includeAny="false" includeEmpty="true"/>
     <rejectableContext includeAny="true"  includeEmpty="false">
@@ -126,4 +128,6 @@
     <concept>http://www.isocat.org/datcat/DC-5361</concept> <!-- language usage (TEI) -->
     <concept>http://www.isocat.org/datcat/DC-5358</concept> <!--language (TEI) - MENZO: added for CLARIN-DK -->
+    
+    <concept>http://purl.org/dc/terms/language</concept>
    <!-- Had to be removed due to IDSAGD_Speaker <acceptableContext includeAny="false" includeEmpty="true"/>
     <rejectableContext includeAny="true"  includeEmpty="false">
Index: /vlo/branches/vlo-3.0/vlo-importer/src/main/java/eu/clarin/cmdi/vlo/importer/LanguageCodePostProcessor.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-importer/src/main/java/eu/clarin/cmdi/vlo/importer/LanguageCodePostProcessor.java	(revision 4574)
+++ /vlo/branches/vlo-3.0/vlo-importer/src/main/java/eu/clarin/cmdi/vlo/importer/LanguageCodePostProcessor.java	(revision 4575)
@@ -32,4 +32,5 @@
     private Map<String, String> languageNameToIso639Map;
     private Map<String, String> iso639ToLanguageNameMap;
+    private Map<String, String> iso639_2TToISO639_3Map;
 
     /**
@@ -73,4 +74,10 @@
             }
         }
+        
+        // convert ISO 639-2/T codes to ISO 639-3
+        if (getIso6392TToISO6393Map().containsKey(value.toUpperCase())) {
+            result = getIso6392TToISO6393Map().get(value.toUpperCase());
+        }
+        
         // Convert to lowercase to capture erroneously capitalized language codes in the CMDI files.
         // NOTE: In the mappings themselves we do not capitalize.
@@ -122,4 +129,39 @@
 
     	return iso639ToLanguageNameMap;
+    }
+    
+    /**
+     * Returns map of ISO 639-2/B codes to ISO 639-3
+     * 
+     *  It is strongly advised to use ISO 639-3 codes, the support for ISO 639-2 may be discontinued in the future
+     * 
+     * @return map of ISO 639-2/B codes to ISO 639-3
+     */
+    private Map<String, String> getIso6392TToISO6393Map() {
+        if (iso639_2TToISO639_3Map == null) {
+            iso639_2TToISO639_3Map = new HashMap<String, String>();
+            iso639_2TToISO639_3Map.put("ALB", "SQI");
+            iso639_2TToISO639_3Map.put("ARM", "HYE");
+            iso639_2TToISO639_3Map.put("BAQ", "EUS");
+            iso639_2TToISO639_3Map.put("BUR", "MYA");
+            iso639_2TToISO639_3Map.put("CZE", "CES");
+            iso639_2TToISO639_3Map.put("CHI", "ZHO");
+            iso639_2TToISO639_3Map.put("DUT", "NLD");
+            iso639_2TToISO639_3Map.put("FRE", "FRA");
+            iso639_2TToISO639_3Map.put("GEO", "KAT");
+            iso639_2TToISO639_3Map.put("GER", "DEU");
+            iso639_2TToISO639_3Map.put("GRE", "ELL");
+            iso639_2TToISO639_3Map.put("ICE", "ISL");
+            iso639_2TToISO639_3Map.put("MAC", "MKD");
+            iso639_2TToISO639_3Map.put("MAO", "MRI");
+            iso639_2TToISO639_3Map.put("MAY", "MSA");
+            iso639_2TToISO639_3Map.put("PER", "FAS");
+            iso639_2TToISO639_3Map.put("RUM", "RON");
+            iso639_2TToISO639_3Map.put("SLO", "SLK");
+            iso639_2TToISO639_3Map.put("TIB", "BOD");
+            iso639_2TToISO639_3Map.put("WEL", "CYM");
+        }
+        
+        return iso639_2TToISO639_3Map;
     }
 
Index: /vlo/branches/vlo-3.0/vlo-importer/src/test/java/eu/clarin/cmdi/vlo/importer/LanguageCodePostProcessorTest.java
===================================================================
--- /vlo/branches/vlo-3.0/vlo-importer/src/test/java/eu/clarin/cmdi/vlo/importer/LanguageCodePostProcessorTest.java	(revision 4574)
+++ /vlo/branches/vlo-3.0/vlo-importer/src/test/java/eu/clarin/cmdi/vlo/importer/LanguageCodePostProcessorTest.java	(revision 4575)
@@ -30,4 +30,5 @@
         assertEquals("German", processor.process("RFC1766:x-sil-GER"));
         assertEquals("RFC1766:sgn-NL", processor.process("RFC1766:sgn-NL"));
+        assertEquals("Basque", processor.process("baq"));
     }
 